package com.robert_franz.serialize;

import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.nio.channels.Channel;

/**
 * User: Robert Franz
 * Date: 22.11.13
 * Time: 21:06
 */
public class ByteBufferSerializationTest
{
	@Test
	public void performance() throws ClassNotFoundException, IOException
	{
		long n = 1000_000;
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;

		long start = System.currentTimeMillis();
		for (int i = 0; i < n; i++)
		{
			byte[] array = serialize(testobject);
			deserialize(array);
		}
		long end = System.currentTimeMillis();
		System.out.println("ByteBuffer:" + (end - start) + "ms");

	}

	@Test
	public void size() throws IOException
	{
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;
		byte[] array = serialize(testobject);
		System.out.println(array.length);
	}

	public byte[] serialize(Testobject o)
	{
		java.nio.ByteBuffer buffer = java.nio.ByteBuffer.allocate(100);
		buffer.putInt(o.b);
		buffer.putLong(o.c);
		int length = o.a.length();
		buffer.putInt(length);
		for (int i = 0; i < length; i++)
			buffer.putChar(o.a.charAt(i));

		byte[] result = new byte[buffer.position()];
		System.arraycopy(buffer.array(),0,result,0,buffer.position());

		return result;
	}

	public Testobject deserialize(byte[] a)
	{
		java.nio.ByteBuffer buffer = java.nio.ByteBuffer.wrap(a);
		Testobject klasse = new Testobject();
		klasse.b = buffer.getInt();
		klasse.c = buffer.getLong();
		int length = buffer.getInt();
		char[] string = new char[length];
		for (int i = 0; i < length; i++)
			string[i] = buffer.getChar();

		klasse.a = String.valueOf(string);
		return klasse;
	}
}
