package com.robert_franz.serialize;

import java.io.IOException;

import org.junit.Test;

public class CopyConstructorTest {

    @Test
    public void performance() throws ClassNotFoundException, IOException {
        long n = 1000_000;
        CopyTestObject testobject = new CopyTestObject();
        testobject.a = "abc";
        testobject.b = 10;
        testobject.c = 100;

        long start = System.currentTimeMillis();
        for (int i = 0; i < n; i++) {
            copy(testobject);
        }
        long end = System.currentTimeMillis();
        System.out.println("Java Copy Constructor:" + (end - start) + "ms");
    }

    public CopyTestObject copy(CopyTestObject object) {
        return new CopyTestObject(object);
    }

    public static class CopyTestObject {

        String a;
        int b;
        long c;

        CopyTestObject()
        {

        }

        CopyTestObject(CopyTestObject object) {
            a = object.a;
            b = object.b;
            c = object.c;
        }
    }
}
