package com.robert_franz.serialize;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.junit.Test;

import java.io.IOException;

/**
 * User: Robert Franz
 * Date: 22.11.13
 * Time: 23:59
 */
public class JacksonSerializationTest
{
	ObjectMapper mapper = new ObjectMapper();

	@Test
	public void performance() throws ClassNotFoundException, IOException
	{
		long n = 1000_000;
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;

		long start = System.currentTimeMillis();
		for (int i = 0; i < n; i++)
		{
			byte[] array = serialize(testobject);
			deserialize(array);
		}
		long end = System.currentTimeMillis();
		System.out.println("Jackson:" + (end - start) + "ms");

	}

	@Test
	public void size() throws IOException
	{
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;
		byte[] array = serialize(testobject);
		System.out.println(array.length);
	}

	public byte[] serialize(Object o) throws IOException
	{
		return mapper.writeValueAsBytes(o);
	}

	public Object deserialize(byte[] a) throws IOException, ClassNotFoundException
	{
		return mapper.readValue(a, Testobject.class);
	}
}
