package com.robert_franz.serialize;

import org.junit.Before;
import org.junit.Test;
import sun.misc.Unsafe;

import java.io.IOException;
import java.lang.reflect.Field;

/**
 * User: Robert Franz
 * Date: 22.11.13
 * Time: 21:06
 */
public class UnsafeSerializationTest
{
	Unsafe unsafe;

	@Before
	public void setUp() throws IllegalAccessException, NoSuchFieldException
	{

	}

	@Test
	public void performance() throws ClassNotFoundException, IOException, NoSuchFieldException, IllegalAccessException
	{
		Field f = Unsafe.class.getDeclaredField("theUnsafe");
		f.setAccessible(true);
		unsafe = (Unsafe) f.get(null);

		long n = 1000_000;
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;

		long start = System.currentTimeMillis();
		for (int i = 0; i < n; i++)
		{
			byte[] array = serialize(testobject);
			deserialize(array);
		}
		long end = System.currentTimeMillis();
		System.out.println("Unsafe:" + (end - start) + "ms");

	}

	public byte[] serialize(Testobject o) throws NoSuchFieldException, IllegalAccessException
	{
		byte[] array = new byte[100];
		unsafe.putLong(array,Unsafe.ARRAY_BYTE_BASE_OFFSET+0L,o.c);
		unsafe.putInt(array, Unsafe.ARRAY_BYTE_BASE_OFFSET + 8L, o.b);
		int length = o.a.length();
		unsafe.putInt(array,Unsafe.ARRAY_BYTE_BASE_OFFSET+12L,length);
		for (int i = 0; i < length; i++)
			unsafe.putChar(array, Unsafe.ARRAY_BYTE_BASE_OFFSET + 16L + i, o.a.charAt(i));

		byte[] result = new byte[Unsafe.ARRAY_BYTE_BASE_OFFSET+19];
		System.arraycopy(array,0,result,0,Unsafe.ARRAY_BYTE_BASE_OFFSET+19);

		return result;
	}

	public Testobject deserialize(byte[] a)
	{

		java.nio.ByteBuffer buffer = java.nio.ByteBuffer.wrap(a);
		Testobject klasse = new Testobject();

		klasse.c = unsafe.getLong(a,Unsafe.ARRAY_BYTE_BASE_OFFSET+0L);
		klasse.b = unsafe.getInt(a,Unsafe.ARRAY_BYTE_BASE_OFFSET+8L);
		int length = unsafe.getInt(a,Unsafe.ARRAY_BYTE_BASE_OFFSET+12L);
		char[] string = new char[length];
		for (int i = 0; i < length; i++)
			string[i] = unsafe.getChar(a,Unsafe.ARRAY_BYTE_BASE_OFFSET+16L+i);

		klasse.a = String.valueOf(string);
		return klasse;
	}
}
